/*----------------------------------*\
  @OBJECTS #FLEX-GRID
\*----------------------------------*/

/* by Nikola Jovanovic - coderman, v2.0, 2020 */
.flex {
  display: flex;
}

.container {
  margin-left: auto;
  margin-right: auto;
  width: 100%;
  max-width: ($container + $gutter * 2);
  padding: 0 $gutter;
}

.container--sm {
  max-width: rem-calc(760);
}

.row {
  display: flex;
  flex: 0 1 auto;
  flex-direction: row;
  flex-wrap: wrap;

  margin-left: -$gutter;
  margin-right: -$gutter;

  > * {
    padding: 0 $gutter;
  }
}

.row--vertical {
  margin: -$gutter;

  > * {
    padding: $gutter;
  }
}

.column {
  @extend .row;
  flex-direction: column;
}

// General column styles
[class^="col-"] {
  width: 100%;
  box-sizing: border-box;
  flex: 0 0 auto;

  &:before,
  &:after {
    display: none !important;
  }
}

.row {
  flex-direction: row;
}

.row-rev {
    flex-direction: row-reverse;
}

.column {
  flex-direction: column;

}

.column-rev {
  flex-direction: column-reverse;
}

// GENERATE GRID ELEMENTS
// List of elements to be created

// Grid columns [breakpoint, column]
// For example:
// md: 6 --> .col-md-6
// null: 3 --> .col-3
// xs: 9 --> .col-xs-9
$breakpoint-column: (
  null: (6),
  xs: (6),
  sm: (3, 4, 6, 8, 9),
  md: (2, 3, 4, 6, 8, 9, 10),
  lg: ()
);

// Grid offsets [breakpoint, column]
// For example:
// md: 6 --> .offset-md-6
// null: 3 --> .offset-3
// xs: 9 --> .offset-xs-9
$breakpoint-offset: (
  sm: (2),
  md: (3)
);

// Grid main axis alignment [breakpoint, alignment]
// Alignments: start, end, center, around between;
// for ex.: md: end
$breakpoint-justify: ();

// Grid main axis alignment [breakpoint, alignment]
// Alignments: top, bottom, middle, stretch;
// for ex.: sm: bottom
$breakpoint-align: ();

// Columns
@include create-columns;

// Column Offsets
@include create-column-offsets;

// Justify breakpoints
@each $breakpoint, $justify in $breakpoint-justify {
  @if $breakpoint == null {
    .#{sanitize-flex-justify($justify)} {
      justify-content: $justify;
    }
  } @else {
    @media (min-width: map-get($breakpoints, $breakpoint)) {
      .#{$justify}-#{$breakpoint} {
        justify-content: sanitize-flex-justify($justify);
      }
    }
  }
}

// Align breakpoints
@each $breakpoint, $align in $breakpoint-align {
  @if $breakpoint == null {
    .#{$align} {
      align-items: sanitize-flex-align($align);
    }
  } @else {
    @media (min-width: map-get($breakpoints, $breakpoint)) {
      .#{$align}-#{$breakpoint} {
        align-items: sanitize-flex-align($align);
      }
    }
  }
}
